#ifndef CommandLineH
#define CommandLineH

#include <SysUtils.hpp>
#include <Classes.hpp>

// s DOS R}h Process Priority \킷񋓌^
enum TCommandLinePriorityType { dcpRealTime, dcpHigh, dcpNormal, dcpIdle };

// 1 s󂯎Cxg֐̌^
typedef void __fastcall ( __closure *TGetStringProc )( TObject* Sender, const AnsiString& Str );


// 1 󂯎Cxg֐̌^
typedef void __fastcall ( __closure *TGetCharProc )( TObject* Sender, char Ch );

//---------------------------------------------------------------------------
// DOS R}hsR|[lgNX
//---------------------------------------------------------------------------
class PACKAGE TCommandLine : public TComponent
{
public:
	__fastcall TCommandLine(TComponent* Owner);

	__fastcall ~TCommandLine();

	// DOS R}hs
	bool __fastcall Execute(
		const AnsiString& command,
		const AnsiString& dir = "",
		void* env = NULL);  // ϐ

	// DOS R}hsI҂
	void __fastcall WaitForTermination();

	// DOS R}hI
	void __fastcall Terminate();

    // ϐ擾
    bool __fastcall GetEnv();

	// ϐubNTCY擾
	int __fastcall GetEnvBlkSize();

	// ϐubN擾
	bool __fastcall GetEnvBlk(int size, void* blk);

__published:
	// DOS R}hsǂ\킷vpeB
	__property bool IsOnExecution = { read = FIsOnExecution, default = false };

	// s DOS R}h̃^[R[h
	__property DWORD ExitCode = { read = FExitCode, default = 0 };

	// s DOS R}h Process Priority
	__property TCommandLinePriorityType Priority =
		{ read = FPriority, write = FPriority, default = dcpNormal };

	// 1 o̓Cxg
	__property TGetCharProc OnOutputChar
		= { read = FOnOutputChar, write = FOnOutputChar, default = NULL };

	// 1 so̓Cxg
	__property TGetStringProc OnOutputLine
		= { read = FOnOutputLine, write = FOnOutputLine, default = NULL };

	// R}hsICxg
	__property TNotifyEvent OnTerminate
		= { read = FOnTerminate, write = FOnTerminate, default = NULL };

	// ϐꗗ
	__property TStringList* Env = { read = FEnv, write = FEnv, default = NULL };

protected:
	class TPipeReader;

	SECURITY_ATTRIBUTES sa;
	SECURITY_DESCRIPTOR sd;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	HANDLE hReadPipe, hWritePipe;	// ǂݍ݁EݗppCv
	TPipeReader* reader;			// pCvǂݍ݃Xbh

	bool FIsOnExecution;			// R}hsǂ\킷tO
	DWORD FExitCode;				// R}h̃^[R[h
	TCommandLinePriorityType FPriority;	// s DOS R}h
										// Process Priority
    TStringList* FEnv;              // ϐ

	TGetCharProc FOnOutputChar;		// 1 o̓Cxg
	TGetStringProc FOnOutputLine;	// 1 so̓Cxg
	TNotifyEvent FOnTerminate;		// R}hICxg

	void __fastcall ProcessTerminate( TObject* Sender );

private:
	//---------------------------------------------------------------------------
	// pCv當ǂݎ邽߂̃XbhNX
	//---------------------------------------------------------------------------
	class TPipeReader : public TThread
	{
	private:
		HANDLE hReadPipe;		// ǂݍݗppCṽnh
		HANDLE hProcess;		// vZX̃nh
		TCommandLine* Owner;		// pCvǂݎXbhNX̃I[i[

		char Buf;				// 1 ǂݍݗpobt@
		AnsiString LineBuffer;	// 1 sǂݍݗpobt@
		TGetCharProc OnOutputChar;		// 1 o͎ɌĂԃCxg֐
		TGetStringProc OnOutputLine;	// 1 so͎ɌĂԃCxg֐

		bool EnvFlag;					// ϐ擾tO

	protected:
		void __fastcall Execute();
		void __fastcall CallOnOutputChar();
		void __fastcall CallOnOutputLine();

	public:
		__fastcall TPipeReader( bool CreateSuspended, TCommandLine* AnOwner,
			HANDLE hAReadPipe, HANDLE hAProcess, TGetCharProc AnOnOutputChar,
			TGetStringProc AnOnOutputLine );

		void __fastcall SetEnvFlag(bool flag);	// tOݒ
		bool __fastcall GetEnvFlag();			// tO擾
	};
};

#endif  // CommandLineH
